using namespace std;

#include "member_two.h"

MemberTwo::MemberTwo (DCDT_Agora* agora)
:DCDT_Member(agora,75000 )
{
};

MemberTwo::~MemberTwo()
{
};

void
MemberTwo::Init()
{
  printf("MemberTwo: Initializing\n");
  fflush(stdout);

  SubscribeMsgType(1);
  SubscribeMsgType(3);
  SubscribeMsgType(4);

  LAT_DEADLINE( 1, ((double)75000)/1000000.0 );
};

void
MemberTwo::DoYourJob (int par)
{
  char *text;

  LAT_SAMPLE( 1, Exit(); );
  DCDT_Msg *txMsg = CreateMsg(2);
  txMsg->SetDeliveryWarranty(10);
  text = (char *)malloc(30);
  strcpy(text, "Ciao, sono due");
  txMsg->SetPayload(text, strlen(text)+1);
  //cout << "\nM2: Sharing msg type 2";
  ShareMsg( txMsg );


  const DCDT_Msg* rxMsg = ReceiveMsg( false );
  if (rxMsg) {
    //cout << "\nM2: Received msg type " << rxMsg->ReadType() << "\nPayload: " << (char*)rxMsg->GetPayload();
  }

  rxMsg = ReceiveMsg( false );
};

void
MemberTwo::Close()
{
};


