#include "member_load_cpu.h"

MemberLoadCpu::MemberLoadCpu (DCDT_Agora* dis, struct cpu_load_t * cpu_l, long int * cur_loop_ptr)
  :DCDT_Member(dis,TIME_LOAD_MSECS *1000 )
{
  //  this->threadZero=threadZero;

  current_loop = cur_loop_ptr;

  strFileUptime="/proc/uptime";
  last_uptime=0;
  last_idletime=0;
  count_loops=0;
  fileUptime=fopen(strFileUptime,"r");
  fscanf(fileUptime,"%f %f",&last_uptime,&last_idletime);
  desp=last_uptime;
  fclose(fileUptime);

  cpu_load = cpu_l; 
 
};

MemberLoadCpu::~MemberLoadCpu()
{

   free(cpu_load);
};

void MemberLoadCpu::Init()
{
  SubscribeMsgType(STOP_MSG);
  fflush(stdout);
};

void MemberLoadCpu::DoYourJob (int par)
{
  //wake++;
  //  long int loop=threadZero->getCountLoop();
  
  DCDT_Msg* rxMsg;
  
 
  //	cpu_load=(struct cpu_load_t*)realloc(cpu_load,sizeof(struct cpu_load_t)*(count_loops+1));

  fileUptime=fopen(strFileUptime,"r");
  fscanf(fileUptime,"%f %f",&up_time, &idle_time);
  fclose(fileUptime);
//  printf("\n*****loop=%d********%f ****** time = %f idle %f\t",*current_loop, up_time-desp, up_time, idle_time);

  cpu_load[count_loops].time=up_time-desp;
  //  fclose(fileUptime);

  up_time-=last_uptime;
  last_uptime+=up_time;
  idle_time-=last_idletime;
  last_idletime+=idle_time;

  if (up_time!=0 && *current_loop >2)
    {
      cpu_load[count_loops].load=100.0-((idle_time/up_time)*100.0);

//      printf("load = %f\n", cpu_load[count_loops].load);

      cpu_load[count_loops].loop = *current_loop;

      count_loops++;
      /*
	if(par!=-1)
	{
	cpu_load[count_loops].loop=loop;
	count_loops++;\
	}
	else
	{
	cpu_load[count_loops].loop=-1;
	//printf("loop=%ld, count_loops=%d\n",cpu_load[count_loops].loop,count_loops);
	}
	//printf("%f, loop=%ld\n",100-((idle_time*100)/up_time), cpu_load[count_loops].loop);
	*/
    }
  //     count_loops++;

  if ( (rxMsg = ReceiveMsg()))
    {
      //      loop=threadZero->getNumLoops()-1;
      cpu_load[count_loops].loop=-1;
      //      cpu_load[count_loops].time=up_time-desp;
      Status=TERMINATING;
    }
 
};


void MemberLoadCpu::Close()
{
  //printf("End of Thread num %d\n",id_thread);
  /*printf("\nMember0 Ho ricevuto %d msg di tipo 1\n",message_received_one);
    printf("Member0 Ho ricevuto %d msg di tipo 2\n",message_received_two);
    printf("Member0 Ho ricevuto %d msg di tipo 3\n",message_received_three);
    printf("Member0 Abbiamo %d errori sui messaggi\n",err);*/
};

struct cpu_load_t* MemberLoadCpu::GetData()
{
  return cpu_load;
}

