#ifndef MEMBER_ZERO_H
#define MEMBER_ZERO_H


#include <DCDT_Member.h>
#include <DCDT_Agora.h>
#include <DCDT_Msg.h>
#include "const.h"
#include "types.h"

extern int current_loop;

class MemberZero : public DCDT_Member
{
 public:

  MemberZero(DCDT_Agora*,struct parameters*, int, long int*);
  ~MemberZero();

  void Init();
  void Close();
  void DoYourJob(int =0);
  struct results_t* GetData();
  long int getCountLoop();
  long int getPeriod();
  long int getNumLoops();
  long int getLostDeadLines();

 private:
  DCDT_Msg * newMsg;

  int id_thread;
  DCDT_TIME period;
  int standard, mathFuncs,memory;//,io;
  long int mem_size;//, io_size;
  long int num_loops;
  long int count_loops;
  long int lost_deadlines;

  long int * current_loop;

  //  int loop_counter; // counter reporting the loop number
  int ID;
  
  int f;
  int message_received_one;
  int message_received_two;
  int message_received_three;
  int wake,err;
  int infoType[2];

  struct results_t *exec_data;

};

#endif
