#include "MsgMgr1.h"
#include "MsgMgr2.h"
#include <unistd.h>

int main( int arc, char *argv[] ) 
{
  char hostname[80];
  ModuleDispatch *Dispatch=NULL;
  MsgMgrOne *MsgMgr1=NULL;
  MsgMgrTwo *MsgMgr2=NULL;

  gethostname( hostname, 80 );
  Dispatch = new ModuleDispatch( "../dcdt.conf", hostname );

  // Consumer
  MsgMgr1 = new MsgMgrOne(Dispatch,200000);

  // Producer
  MsgMgr2 = new MsgMgrTwo(Dispatch,100000);

  if ( MsgMgr1 )  
     Dispatch->AddMember(MsgMgr1);

  if ( MsgMgr2 )
     Dispatch->AddMember(MsgMgr2);
 
  printf("\n\nPress a key to create the Community\n\n");
  getchar();

  if ( MsgMgr1 )
     Dispatch->ActivateMember(MsgMgr1);

  if ( MsgMgr2 )
     Dispatch->ActivateMember(MsgMgr2);

  printf("\n\nPress a key and ''let's work, be proud...'' \n\n");
  getchar();

  Dispatch->LetsWork();

  if ( MsgMgr1 ) {
     printf("Deleting MsgMgr1\n");
     delete MsgMgr1;
  }

  if ( MsgMgr2 ) {
     printf("Deleting MsgMgr2\n");
     delete MsgMgr2;
  }

  if ( Dispatch ) {
     printf("Deleting Dispatch\n");
     delete Dispatch;
  }

  printf("\n\nCommunity Session Terminated\n\n");

  return 0;
}
