#include "Member1.h"

StringMemberOne::StringMemberOne (ModuleDispatch *dispatch, int period)
:StringModuleMember(dispatch,period,"StringMemberOne")
{
};

StringMemberOne::~StringMemberOne()
{
};

void StringMemberOne::RunInit()
{
  printf("\nMemberOne: Initializing\n");
  fflush(stdout);

  AddMessageRequest( 1, LOCAL );
  AddMessageRequest( 2, REMOTE );
  AddMessageRequest( 2, LOCAL );
};

void StringMemberOne::RunDuty()
{
  static int count=0;
  int length;
  short unsigned int type;
  unsigned char *msg;

  type=0;
  length = ReceiveMessage( type, msg );
  if ( length > 0 ) {
     printf ( "Msg type %d: <%s> (%d)\n", type, msg, count );
     count++;
  }

  if ( count > 200 )
     Terminate(5);

};

void StringMemberOne::RunClose()
{
};
