#ifndef FireRawAcquisitionW_h
#define FireRawAcquisitionW_h

#include <stdio.h>
#include <libraw1394/raw1394.h>
#include <libdc1394/dc1394_control.h>
#include <stdlib.h>

#include "VideoAcquisitionWheelchair.h"

using namespace std;

class FileRawAcquisition : public VideoAcquisitionWheelchair
{
	string header;
	string tailer;
	string format;
	unsigned char * mpImage;
	int count;

	string createFileName();
	inline int getCount(){return count;};
public:

	FileRawAcquisition(string header,string tailer,string format);
	~FileRawAcquisition();

	void Start();
	void Stop();
	bool isReady();
	unsigned char* CaptureFrame();

	static const int image_width 	=640;
	static const int image_height 	=480;
};
 
#endif
