#ifndef InverseMatrixCorrection_h
#define InverseMatrixCorrection_h

#include "Matrix3DRotoTraslation.h"
#include "Param3DRotoTraslation.h"

#include <string>
#include <map>

using namespace std;

class InverseMatrixCorrection{
	map<int,Param3DRotoTraslation *> tagParam;
	Matrix3DRotoTraslation * result;

	public:
		InverseMatrixCorrection();
		~InverseMatrixCorrection();
		void addTag(int numTag,double z,double b,double c);
		int getInverseMatrix(Matrix3DRotoTraslation *in,int numTag);
		int getCorrectedMatrix(Matrix3DRotoTraslation *in,int numTag);
		inline Matrix3DRotoTraslation * getResult(){return result;};
};

#endif
