#ifndef MatrixFunctions_h
#define MatrixFunctions_h

#include "Matrix3DRotoTraslation.h"
#include "Param3DRotoTraslation.h"
#include "stdio.h"
#include <string>

using namespace std;

void print3DMatrix(Matrix3DRotoTraslation *m,string header="",string tailer="",FILE *f=stdout);
void print3DMatrix(Param3DRotoTraslation *p,string header="",string tailer="",FILE *f=stdout);

void print3DParam(Matrix3DRotoTraslation *m,string header="",string tailer="",FILE *f=stdout);
void print3DParam(Param3DRotoTraslation *p,string header="",string tailer="",FILE *f=stdout);

Matrix3DRotoTraslation * toMatrix3DRotoTraslation(Param3DRotoTraslation *p);
Param3DRotoTraslation * toParam3DRotoTraslation(Matrix3DRotoTraslation *m);

Matrix3DRotoTraslation *multMatrix3D(Matrix3DRotoTraslation *m1,Matrix3DRotoTraslation *m2);
Matrix3DRotoTraslation *multMatrix3D(Param3DRotoTraslation *p1,Matrix3DRotoTraslation *m2);
Matrix3DRotoTraslation *multMatrix3D(Matrix3DRotoTraslation *m1,Param3DRotoTraslation *p2);
Matrix3DRotoTraslation *multMatrix3D(Param3DRotoTraslation *p1,Param3DRotoTraslation *p2);

Matrix3DRotoTraslation *invMatrix3D(Matrix3DRotoTraslation *m1);
Matrix3DRotoTraslation *invMatrix3D(Param3DRotoTraslation *p1);

#endif

