#include "member_zero.h"

MemberZero::MemberZero (DCDT_Agora* dis)
  :DCDT_Member(dis,500000 )
{

};

MemberZero::~MemberZero()
{
};

void MemberZero::Init()
{
  printf("MemberZero: Initializing\n");
  fflush(stdout);

  SubscribeMsgType(2);
  SubscribeMsgType(3);

  message_received_one=0;
  message_received_two=0;
  message_received_three=0;
  wake=0;
  err=0;  

  // SetActivationCondition(GetAllMsgTypeMask());
};

void MemberZero::DoYourJob (int par)
{
  wake++;

  DCDT_Msg* rxMsg = ReceiveMsg();

  DCDT_Msg* newMsg = CreateMsg(2) ;
  ShareMsg( newMsg );
  
  /*
    if( rxMsg )
    printf("Ricevuto Msg %d", rxMsg->ReadType() );
  */

  printf("*");fflush(stdout);
  

  while(rxMsg!=NULL)
    {
      if(rxMsg->ReadType()==1) 
	{
          printf("|1|");fflush(stdout);
          message_received_one++;  
	}

      else if(rxMsg->ReadType()==2)
	{
          printf("|2|");fflush(stdout);
          message_received_two++;
	}
      else if(rxMsg->ReadType()==3)
	{
          printf("|3|");fflush(stdout);
          message_received_three++;
	}
#ifdef TOTAL_LOCK
      RemoveCurrMsg();
#endif
      //  if(*((char *)rxMsg->GetPayload())!=CONTENUTO_MSG) err++; 
      rxMsg = ReceiveMsg();
      //      printf("Giro\n");
    }
};

void MemberZero::Close()
{
  printf("\nMember0 Ho ricevuto %d msg di tipo 1\n",message_received_one);
  printf("Member0 Ho ricevuto %d msg di tipo 2\n",message_received_two);
  printf("Member0 Ho ricevuto %d msg di tipo 3\n",message_received_three);
  printf("Member0 Abbiamo %d errori sui messaggi\n",err);
};


