/****************************************************************************
dEVICE cOMMUNITIES dEVELOPMENT tOOLKIT 

DCDT_MsgManager.cpp

COPYRIGHT (C) 2002  Paolo Meriggi (meriggi@ing.unibs.it)
                    Cristian Giussani (cgiussani@fastflow.it)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.

****************************************************************************/

#ifndef DCDT_MSGMANAGER_CPP
#define DCDT_MSGMANAGER_CPP

#include <DCDT_MsgManager.h>
#include <DCDT_Agora.h>

DCDT_MsgManager::DCDT_MsgManager(DCDT_Agora* agora)
  : DCDT_Member( agora, 500000 )
{
  
  
};

DCDT_MsgManager::~DCDT_MsgManager() {

};

/*! \brief Clean the message queue every 10s
 */
void DCDT_MsgManager::DoYourJob(int par) {
  myPostOffice->CleanupList();
  
  //Delay(10000);
}

void DCDT_MsgManager::Init() {
  TRC_PRINT( DCDT_TRC_COMM, TRC1, ("MsgManager Initializinig"));  
};

void DCDT_MsgManager::Close() {
  TRC_PRINT( DCDT_TRC_COMM, TRC1,("MsgManager Closing"));  
};

#endif //define
