#include <MessageManager.h>
#include "MsgMgr1.h"
#include "MsgMgr2.h"

int main( int arc, char *argv[] ) 
{
  ModuleDispatch *Dispatch;
  MsgMgrOne *MsgMgr1;
  MsgMgrTwo *MsgMgr2;

  Dispatch = new ModuleDispatch( "../dcdt.conf", "hostname" );
  MsgMgr1 = new MsgMgrOne(Dispatch,1000000);
  MsgMgr2 = new MsgMgrTwo(Dispatch,1000000);
  
  Dispatch->AddMember(MsgMgr1);
  Dispatch->AddMember(MsgMgr2);
 
  printf("\n\nPress a key to create the Community\n\n");
  getchar();

  Dispatch->ActivateMember(MsgMgr1);
  Dispatch->ActivateMember(MsgMgr2);

  printf("\n\nPress a key and ''let's work, be proud...'' \n\n");
  getchar();

  Dispatch->LetsWork();

  delete MsgMgr1;
  delete MsgMgr2;

  delete Dispatch;

  printf("\n\nCommunity Session Terminated\n\n");

  return 0;
}
