#include "MsgMgr2.h"

MsgMgrTwo::MsgMgrTwo (ModuleDispatch *dispatch, unsigned int period)
//:StringMessageManager(dispatch,period,"MsgMgrTwo")
:ModuleExpert(dispatch, period),StringMessageManager(dispatch,period,"MsgMgrTwo")
{
};

MsgMgrTwo::~MsgMgrTwo()
{
};

void
MsgMgrTwo::RunInit()
{
   AddMessageRequest( 2, LOCAL );
};

void
MsgMgrTwo::RunDuty()
{
   static int counter=0;
   int idmy;
   ostringstream msg;
  
   msg << "Msg tipo 1 (" << counter++ << ")";
   NewMessage( 1, msg.str() );
   CloseCurrentMessage();
   SendAllStringMessages();

   CancelAllStringMessages();
   ReceiveAllStringMessages();
   idmy=GetNumberOfReceivedMessages();
   if ( idmy > 0 ) {
      cout << "Received termination signal" << endl;
      cout << counter << " messages sent." << endl;
      Exit();
   }
};

void
MsgMgrTwo::RunClose()
{
};
