#include "Member1.h"
#include "Member2.h"

int main( int arc, char *argv[] ) 
{
  ModuleDispatch *Dispatch;
  StringMemberOne *Mb1;
  StringMemberTwo *Mb2;

  Dispatch = new ModuleDispatch( "../dcdt.conf", "hostname" );
  Mb1 = new StringMemberOne(Dispatch,100000);
  Mb2 = new StringMemberTwo(Dispatch,100000);
  
  Dispatch->AddMember(Mb1);
  Dispatch->AddMember(Mb2);
 
  printf("\n\nPress a key to create the Community\n\n");
  getchar();

  Dispatch->ActivateMember(Mb1);
  Dispatch->ActivateMember(Mb2);

  printf("\n\nPress a key and ''let's work, be proud...'' \n\n");
  getchar();

  Dispatch->LetsWork();

  delete Mb1;
  delete Mb2;

  delete Dispatch;

  printf("\n\nCommunity Session Terminated\n\n");

  return 0;
}
