#ifndef WHEELCHAIRUTIL_H_
#define WHEELCHAIRUTIL_H_

#include <string>
#include <sstream>
#include <iostream>
#include <vector>

//#define DEBUG2
#ifdef DEBUG2
	#define DBG(x,...) do{fprintf(stderr,x,##__VA_ARGS__);}while(0)
#else
	#define DBG(x,...)
#endif



using namespace std;

bool stringToFloat(float& t, string s);

void printAndDelete(char *s);

float rad2deg(float d);
float deg2rad(float d);

vector<int> semplificaProfilo(float *x,float *y,int n,float errMax);

#endif
