/*
 * AIRboardUI: graphical interface program to interact with airboard
 * through RS232 serial port.
 *
 * In order to compile this package you have to install the
 * Java Communications API on your system.
 * http://java.sun.com/products/javacomm/downloads/index.html
 * 
 * Bruschieri Stefano
 * Campari PierPaolo
 */

package airboardUI;

/**
 * @author Stefano
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Launcher {

    /**
    * Main method. Checks to see if the command line agrument is requesting
    * usage informaition (-h, -help), if it is, display a usage message and
    * exit, otherwise create a new <code>SerialDemo</code> and set it visible.
    */
    public static void main(String[] args) {
	if ((args.length > 0) 
	    && (args[0].equals("-h") 
	    || args[0].equals("-help"))) {
	    System.out.println("usage: java SerialDemo [configuration File]");
	    System.exit(1);
	}
	
	AirboardFrame serialDemo = new AirboardFrame(args);
	serialDemo.setVisible(true);
	serialDemo.repaint();
    }
	
}
