#DefencePredictive

#This behavior should modify Defense behaviors, following the movements of the ball.

#RotSpeed (BallDeltaAngle)
[S]{
(AND	(BallHomeRight)
	(AND	(Ball<N>)
		(BallDeltaAngleRight)))	=>	(TanSpeed <VERY_FAST_FORWARD>)
						(RotSpeed <VERY_FAST_RIGHT>);

(AND	(BallHomeRight)
	(AND	(Ball<N>)
		(BallDeltaAngleLeft)))	=>	(TanSpeed <VERY_SLOW_FORWARD>)
						(RotSpeed <LEFT>);
}
{
(AND	(BallHomeRight)
	(AND	(Ball<NE>)
		(BallDeltaAngleRight)))	=>	(RotSpeed <VERY_FAST_LEFT>)
						(TanSpeed <VERY_FAST_BACKWARD>);

(AND	(BallHomeRight)
	(AND	(Ball<NE>)
		(BallDeltaAngleLeft)))	=>	(RotSpeed <VERY_FAST_RIGHT>);

(AND	(BallHomeRight)
	(AND	(Ball<E>)
		(BallDeltaAngleRight)))	=> 	(RotSpeed <VERY_SLOW_RIGHT>)
						(TanSpeed <VERY_FAST_BACKWARD>);

(AND	(BallHomeRight)
	(AND	(Ball<E>)
		(BallDeltaAngleLeft)))	=> 	(RotSpeed <LEFT>);
}


#TanSpeed (BallDeltaDistance)

(AND	(AND	(BallMovingAway) (ProposedTanFwd))
	(NOT	(OR	(BallE) (BallW))))	=>	(TanSpeed VERY_FAST_FORWARD);

(AND	(AND	(BallMovingAway) (ProposedTanBwd))
	(NOT	(OR	(BallE) (BallW))))	=>	(TanSpeed VERY_FAST_BACKWARD);

(AND	(AND	(BallMovingAway) (ProposedTanSteady))
	(OR	(OR	(BallN) (BallNE))
		(BallNW)))			=>	(TanSpeed VERY_FAST_FORWARD);

(AND	(AND	(BallMovingAway) (ProposedTanSteady))
	(OR	(OR	(BallS) (BallSW))
		(BallSE)))			=>	(TanSpeed VERY_FAST_BACKWARD);

(BallApproaching)	=>	(TanSpeed STEADY);


