
#ifndef wiim_h
#define wiim_h

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <wiiuse.h>
#include <time.h>
#include <math.h>
#include <string>

#include <const.h>
#include <type.h>

using namespace std;

#define MAX_WIIMOTES				1

class Wiim
{

public:
  Wiim();
  ~Wiim();

  int run();
 
  int getEmergencyStop(); 
  string getToMotor();
  int getButtonB();
  int getJButtonHome();
  int getHButtonA();
  void SetCharge(float c);
  int IsAuto();
  float GetAcceleration();
  float getPitch();
  ppoint getcenter();
  
  void BlinkRight(int status);
  void BlinkLeft(int status);
  void WeakRumble(int status);
  void StrongRumble(int status);
  void showPoint();
  void SetpointDiff(int pd);

private:
	wiimote** wiimotes;
	
  	void handle_ctrl_status(struct wiimote_t* wm);
	void handle_event(struct wiimote_t* wm); 
	
	int pointDiff;
	int BlinkRightStatus;
	int BlinkLeftStatus;
	int RumbleWStatus;
	int RumbleSStatus;
	int fAuto;

  
};

#endif
