#include "MatrixFunctions.h"
#include "Matrix3DRotoTraslation.h"
#include "Param3DRotoTraslation.h"
#include "stdio.h"


int main(){
Matrix3DRotoTraslation *m1=new Matrix3DRotoTraslation();
Matrix3DRotoTraslation *m2=new Matrix3DRotoTraslation();
Param3DRotoTraslation *p1=new Param3DRotoTraslation ();
Param3DRotoTraslation *p2=new Param3DRotoTraslation ();

p1->setX(10);
p1->setY(20);
p1->setZ(30);
p1->setA(0);
p1->setB(M_PI/2);
p1->setC(M_PI/4);

delete m1;
m1=toMatrix3DRotoTraslation(p1);

m1->setValue(3,3,3);//questa op non ha effetto, l'ultima riga non si può modificare, è [0 0 0 1]

print3DMatrix(m1,"m1:\n","\n\n");
print3DParam(m1,"m1:\n","\n\n");
print3DMatrix(m2,"m2:\n","\n\n");
print3DParam(m2,"m2:\n","\n\n");

delete m2;
m2=invMatrix3D(m1);
print3DMatrix(m1,"m1\n","\n\n");
print3DMatrix(m2,"m2=inv(m1);\n","\n\n");


Matrix3DRotoTraslation *m3=multMatrix3D(m1,m2);
print3DMatrix(m3,"m3=m1*m2\n","\n\n");

delete p1;
p1=toParam3DRotoTraslation(m1);
print3DMatrix(p1,"p1\n","\n\n");

delete m1;
m1=toMatrix3DRotoTraslation(p2);
print3DMatrix(p1,"p1\n","\n\n");
delete m1;
delete m2;
delete m3;
delete p1;
delete p2;

}
